diff --git a/SHADE_Engine/src/Math/Transform/SHTransformComponent.h b/SHADE_Engine/src/Math/Transform/SHTransformComponent.h
index ad355694..2fe67bdd 100644
--- a/SHADE_Engine/src/Math/Transform/SHTransformComponent.h
+++ b/SHADE_Engine/src/Math/Transform/SHTransformComponent.h
@@ -56,42 +56,52 @@ namespace SHADE
     /* Getter Functions                                                                */
     /*---------------------------------------------------------------------------------*/
 
-    [[nodiscard]] bool                HasChanged        ()  const noexcept;
+    [[nodiscard]] bool                HasChanged          ()  const noexcept;
 
-    [[nodiscard]] const SHVec3&       GetLocalPosition  ()  const noexcept;
-    [[nodiscard]] const SHVec3&       GetLocalRotation  ()  const noexcept;
-    [[nodiscard]] const SHVec3&       GetLocalScale     ()  const noexcept;
-    [[nodiscard]] const SHVec3&       GetWorldPosition  ()  const noexcept;
-    [[nodiscard]] const SHVec3&       GetWorldRotation  ()  const noexcept;
-    [[nodiscard]] const SHVec3&       GetWorldScale     ()  const noexcept;
+    [[nodiscard]] const SHVec3&       GetLocalPosition    ()  const noexcept;
+    [[nodiscard]] const SHVec3&       GetLocalRotation    ()  const noexcept;
+    [[nodiscard]] const SHQuaternion& GetLocalOrientation ()  const noexcept;
+    [[nodiscard]] const SHVec3&       GetLocalScale       ()  const noexcept;
+    [[nodiscard]] const SHVec3&       GetWorldPosition    ()  const noexcept;
+    [[nodiscard]] const SHVec3&       GetWorldRotation    ()  const noexcept;
+    [[nodiscard]] const SHQuaternion& GetWorldOrientation ()  const noexcept;
+    [[nodiscard]] const SHVec3&       GetWorldScale       ()  const noexcept;
 
-    [[nodiscard]] const SHMatrix&     GetLocalToWorld   ()  const noexcept;
-    [[nodiscard]] SHMatrix            GetWorldToLocal   ()  const noexcept;
+    [[nodiscard]] const SHMatrix&     GetLocalToWorld     ()  const noexcept;
+    [[nodiscard]] SHMatrix            GetWorldToLocal     ()  const noexcept;
 
-    [[nodiscard]] const SHMatrix&     GetTRS            ()  const noexcept;
+    [[nodiscard]] const SHMatrix&     GetTRS              ()  const noexcept;
 
     /*---------------------------------------------------------------------------------*/
     /* Setter Functions                                                                */
     /*---------------------------------------------------------------------------------*/
 
-    void  SetLocalPosition  (const SHVec3& newLocalPosition)      noexcept;
-    void  SetLocalRotation  (const SHVec3& newLocalRotation)      noexcept;
-    void  SetLocalRotation  (float pitch, float yaw, float roll)  noexcept;
-    void  SetLocalScale     (const SHVec3& newLocalScale)         noexcept;
-    void  SetWorldPosition  (const SHVec3& newWorldPosition)      noexcept;
-    void  SetWorldRotation  (const SHVec3& newWorldRotation)      noexcept;
-    void  SetWorldRotation  (float pitch, float yaw, float roll)  noexcept;
-    void  SetWorldScale     (const SHVec3& newWorldScale)         noexcept;
+    void  SetLocalPosition    (const SHVec3& newLocalPosition)          noexcept;
+    void  SetLocalRotation    (const SHVec3& newLocalRotation)          noexcept;
+    void  SetLocalRotation    (float pitch, float yaw, float roll)      noexcept;
+    void  SetLocalOrientation (const SHQuaternion& newLocalOrientation) noexcept;
+    void  SetLocalScale       (const SHVec3& newLocalScale)             noexcept;
+    void  SetWorldPosition    (const SHVec3& newWorldPosition)          noexcept;
+    void  SetWorldRotation    (const SHVec3& newWorldRotation)          noexcept;
+    void  SetWorldRotation    (float pitch, float yaw, float roll)      noexcept;
+    void  SetWorldOrientation (const SHQuaternion& newWorldOrientation) noexcept;
+    void  SetWorldScale       (const SHVec3& newWorldScale)             noexcept;
 
   private:
     /*---------------------------------------------------------------------------------*/
     /* Type Definitions                                                                */
     /*---------------------------------------------------------------------------------*/
 
+    // Differentiate between rotation and orientation for setters
+    // Setting a quaternion directly is different from using euler angle rotations.
+
     enum class UpdateCommandType
     {
-      WORLD_POSITION
+      LOCAL_ROTATION
+    , LOCAL_ORIENTATION
+    , WORLD_POSITION
     , WORLD_ROTATION
+    , WORLD_ORIENTATION
     , WORLD_SCALE
     };
 
@@ -103,7 +113,7 @@ namespace SHADE
       /*-------------------------------------------------------------------------------*/
 
       UpdateCommandType type;
-      SHVec3            data;
+      SHVec4            data;
     };
 
     using UpdateQueue = std::queue<UpdateCommand>;
@@ -114,6 +124,12 @@ namespace SHADE
 
     bool        dirty;
 
+    // We store euler angle rotations separately to interface with transform quaternions.
+    // Reading quaternions are unreliable.
+
+    SHVec3      localRotation;    // Stored in Radians
+    SHVec3      worldRotation;    // Stored in Radians
+
     SHTransform local;    // Local TRS holds Local To World Transform
     SHTransform world;
 
diff --git a/SHADE_Engine/src/Math/Transform/SHTransformSystem.cpp b/SHADE_Engine/src/Math/Transform/SHTransformSystem.cpp
index 6b05e323..a2ab6880 100644
--- a/SHADE_Engine/src/Math/Transform/SHTransformSystem.cpp
+++ b/SHADE_Engine/src/Math/Transform/SHTransformSystem.cpp
@@ -17,7 +17,8 @@
 #include "Scene/SHSceneManager.h"
 #include "ECS_Base/Managers/SHComponentManager.h"
 #include "ECS_Base/Managers/SHEntityManager.h"
-#include "Tools/SHException.h"
+#include "ECS_Base/Managers/SHSystemManager.h"
+#include "Math/SHMathHelpers.h"
 
 namespace SHADE
 {
@@ -29,8 +30,12 @@ namespace SHADE
   /* Constructors & Destructor Definitions                                             */
   /*-----------------------------------------------------------------------------------*/
 
-  SHTransformSystem::TransformUpdateRoutine::TransformUpdateRoutine()
-  : SHSystemRoutine { "Transform Update", true }
+  SHTransformSystem::TransformPostLogicUpdate::TransformPostLogicUpdate()
+  : SHSystemRoutine { "Transform Post-Logic Update", true }
+  {}
+
+  SHTransformSystem::TransformPostPhysicsUpdate::TransformPostPhysicsUpdate()
+  : SHSystemRoutine { "Transform Post-Physics Update", false }
   {}
 
 
@@ -38,16 +43,27 @@ namespace SHADE
   /* Public Function Member Definitions                                                */
   /*-----------------------------------------------------------------------------------*/
 
-  void SHTransformSystem::TransformUpdateRoutine::Execute(double) noexcept
+  void SHTransformSystem::TransformPostLogicUpdate::Execute(double) noexcept
   {
     // Get the current scene graph to traverse and update
     const auto& SCENE_GRAPH = SHSceneManager::GetCurrentSceneGraph();
-    UpdateEntity(SCENE_GRAPH.GetRoot());
+
+    // TODO(Diren): Consider how to clear dirty in pause / stop mode and update physics, but do not clear in play mode.
+    UpdateEntity(SCENE_GRAPH.GetRoot(), false);
+  }
+
+  void SHTransformSystem::TransformPostPhysicsUpdate::Execute(double) noexcept
+  {
+    // Get the current scene graph to traverse and update
+    const auto& SCENE_GRAPH = SHSceneManager::GetCurrentSceneGraph();
+    UpdateEntity(SCENE_GRAPH.GetRoot(), true);
   }
 
   void SHTransformSystem::Init()
   {
-
+    const std::shared_ptr CHANGE_PARENT_RECEIVER { std::make_shared<SHEventReceiverSpec<SHTransformSystem>>(this, &SHTransformSystem::ChangeParent) };
+    const ReceiverPtr CHANGE_PARENT_RECEIVER_PTR = std::dynamic_pointer_cast<SHEventReceiver>(CHANGE_PARENT_RECEIVER);
+    SHEventManager::SubscribeTo(SH_SCENEGRAPH_CHANGE_PARENT_EVENT, CHANGE_PARENT_RECEIVER_PTR);
   }
 
   void SHTransformSystem::Exit()
@@ -59,7 +75,53 @@ namespace SHADE
   /* Private Function Member Definitions                                               */
   /*-----------------------------------------------------------------------------------*/
 
-  void SHTransformSystem::UpdateEntity(const SHSceneNode* node)
+  void SHTransformSystem::UpdateChildrenLocalTransforms(SHSceneNode* node)
+  {
+    // Structure is similar to update entity, albeit without a queue to do being a forced update
+    for (const auto* child : node->GetChildren())
+    {
+      if (auto* childTransform = SHComponentManager::GetComponent_s<SHTransformComponent>(child->GetEntityID()); childTransform)
+      {
+        const bool IS_NODE_ACTIVE = child->IsActive();
+        if (IS_NODE_ACTIVE && childTransform->isActive)
+        {
+          // Recompute local transform and store localToWorld Matrix
+          SHMatrix localToWorld = SHMatrix::Identity; 
+          SHMatrix worldToLocal = SHMatrix::Identity;
+
+          const auto* parent = SHComponentManager::GetComponent_s<SHTransformComponent>(node->GetEntityID());
+
+          if (parent != nullptr) // Not the root
+          {
+            localToWorld = parent->GetTRS();
+            worldToLocal = SHMatrix::Inverse(localToWorld);
+          }
+
+          // Maintain World Transform and recompute Local Transform
+
+          // Compute Local Position
+          childTransform->local.position = SHVec3::Transform(childTransform->world.position, worldToLocal);
+
+          
+          childTransform->localRotation = childTransform->worldRotation;
+          childTransform->local.scale   = childTransform->world.scale;
+
+          if (parent)
+          {
+            // Compute Local Rotation
+            childTransform->localRotation -= parent->GetLocalRotation();
+
+            // Compute Local Scale
+            childTransform->local.scale /= parent->GetLocalScale();
+          }
+
+          childTransform->local.trs = localToWorld;
+        }
+      }
+    }
+  }
+
+  void SHTransformSystem::UpdateEntity(const SHSceneNode* node, bool clearDirtyFlag)
   {
     const auto* NODE_TRANSFORM = SHComponentManager::GetComponent_s<SHTransformComponent>(node->GetEntityID());
     const bool HAS_PARENT_CHANGED = NODE_TRANSFORM && NODE_TRANSFORM->dirty;
@@ -74,14 +136,17 @@ namespace SHADE
         if (IS_NODE_ACTIVE && childTransform->isActive)
         {
           if (childTransform->dirty || HAS_PARENT_CHANGED)
+          {
             UpdateTransform(*childTransform, NODE_TRANSFORM);
+            childTransform->dirty = true;
+          }
         }
       }
 
-      UpdateEntity(child);
+      UpdateEntity(child, clearDirtyFlag);
 
       // Clear dirty flag after all children are updated
-      if (childTransform)
+      if (childTransform && clearDirtyFlag)
         childTransform->dirty = false;
     }
   }
@@ -91,6 +156,8 @@ namespace SHADE
     SHMatrix localToWorld = SHMatrix::Identity;
     SHMatrix worldToLocal = SHMatrix::Identity;
 
+    bool convertRotation = true;
+
     if (parent)
     {
       localToWorld = parent->GetTRS();
@@ -103,22 +170,44 @@ namespace SHADE
 
       switch (UPDATE_COMMAND.type)
       {
+        case SHTransformComponent::UpdateCommandType::LOCAL_ROTATION:
+        {
+          convertRotation = true;
+          break;
+        }
+        case SHTransformComponent::UpdateCommandType::LOCAL_ORIENTATION:
+        {
+          convertRotation = false;
+          break;
+        }
         case SHTransformComponent::UpdateCommandType::WORLD_POSITION:
         {
-          tf.local.position = SHVec3::Transform(UPDATE_COMMAND.data, worldToLocal);
+          tf.local.position = SHVec3::Transform(UPDATE_COMMAND.data.ToVec3(), worldToLocal);
           break;
         }
         case SHTransformComponent::UpdateCommandType::WORLD_ROTATION:
         {
-          tf.local.rotation = tf.world.rotation;
+          tf.localRotation = UPDATE_COMMAND.data.ToVec3();
           if (parent)
-            tf.local.rotation -= parent->GetLocalRotation();
+            tf.localRotation -= parent->GetLocalRotation();
+
+          convertRotation = true;
+
+          break;
+        }
+        case SHTransformComponent::UpdateCommandType::WORLD_ORIENTATION:
+        {
+          tf.local.orientation = UPDATE_COMMAND.data;
+          if (parent)
+            tf.local.orientation /= parent->GetLocalOrientation();
+
+          convertRotation = false;
 
           break;
         }
         case SHTransformComponent::UpdateCommandType::WORLD_SCALE:
         {
-          tf.local.scale = tf.world.scale;
+          tf.local.scale = UPDATE_COMMAND.data.ToVec3();
           if (parent)
             tf.local.scale /= parent->GetLocalScale();
 
@@ -133,15 +222,83 @@ namespace SHADE
 
     tf.local.trs = localToWorld;
 
+    // Compute world transforms
     tf.world.position = SHVec3::Transform(tf.local.position, localToWorld);
-    tf.world.rotation = tf.local.rotation + (parent ? parent->GetLocalRotation() : SHVec3::Zero);
     tf.world.scale    = tf.local.scale * (parent ? parent->GetLocalScale() : SHVec3::One);
 
-    tf.world.ComputeTRS();
+    
 
-    // Transpose TRS to column major
-    //tf.local.trs.Transpose();
-    //tf.world.trs.Transpose();
+    if (convertRotation)
+    {
+      tf.worldRotation  = tf.localRotation + (parent ? parent->GetLocalRotation() : SHVec3::Zero);
+
+      // Set the orientation
+      // Wrap rotations between -360 and 360 and convert to radians
+      SHVec3 worldRotRad, localRotRad;
+      for (size_t i = 0; i < SHVec3::SIZE; ++i)
+      {
+        worldRotRad[i] = SHMath::Wrap(tf.worldRotation[i], -SHMath::TWO_PI, SHMath::TWO_PI);
+        localRotRad[i] = SHMath::Wrap(tf.localRotation[i], -SHMath::TWO_PI, SHMath::TWO_PI);
+      }
+
+      tf.world.orientation = SHQuaternion::FromEuler(worldRotRad);
+      tf.local.orientation = SHQuaternion::FromEuler(localRotRad);
+    }
+    else
+    {
+      tf.world.orientation = (parent ? parent->GetLocalOrientation() : SHQuaternion::Identity) * tf.local.orientation;
+
+      // Set the euler angle rotations
+      tf.worldRotation = tf.world.orientation.ToEuler();
+      tf.localRotation = tf.local.orientation.ToEuler();
+    }
+
+    tf.world.ComputeTRS();
+  }
+
+  SHEventHandle SHTransformSystem::ChangeParent(SHEventPtr changeParentEvent)
+  {
+    const auto& EVENT_DATA = reinterpret_cast<const SHEventSpec<SHSceneGraphChangeParentEvent>*>(changeParentEvent.get());
+
+    auto* node = EVENT_DATA->data->node;
+    auto* tf = SHComponentManager::GetComponent_s<SHTransformComponent>(node->GetEntityID());
+
+    // Recompute local transform and store localToWorld Matrix
+    SHMatrix localToWorld = SHMatrix::Identity; 
+    SHMatrix worldToLocal = SHMatrix::Identity;
+
+    auto* newParent = EVENT_DATA->data->newParent;
+    const auto* PARENT_TF = SHComponentManager::GetComponent_s<SHTransformComponent>(newParent->GetEntityID());
+    if (PARENT_TF != nullptr) // Not the root
+    {
+      localToWorld = PARENT_TF->GetTRS();
+      worldToLocal = SHMatrix::Inverse(localToWorld);
+    }
+
+    // Maintain World Transform and recompute Local Transform
+
+    // Compute Local Position
+    tf->local.position = SHVec3::Transform(tf->world.position, worldToLocal);
+
+          
+    tf->localRotation = tf->worldRotation;
+    tf->local.scale   = tf->world.scale;
+
+    if (PARENT_TF != nullptr)
+    {
+      // Compute Local Rotation
+      tf->localRotation -= PARENT_TF->GetLocalRotation();
+
+      // Compute Local Scale
+      tf->local.scale /= PARENT_TF->GetLocalScale();
+    }
+
+    tf->local.trs = localToWorld;
+
+    // Propagate maintaining world transform down the branch
+    UpdateChildrenLocalTransforms(node);
+
+    return EVENT_DATA->handle;
   }
 
 } // namespace SHADE
\ No newline at end of file
diff --git a/SHADE_Engine/src/Math/Transform/SHTransformSystem.h b/SHADE_Engine/src/Math/Transform/SHTransformSystem.h
index 02c3b6c6..bb373f3a 100644
--- a/SHADE_Engine/src/Math/Transform/SHTransformSystem.h
+++ b/SHADE_Engine/src/Math/Transform/SHTransformSystem.h
@@ -11,9 +11,9 @@
 #pragma once
 
 // Project Headers
-#include "SHTransformComponent.h"
-#include "Scene/SHSceneGraph.h"
 #include "ECS_Base/System/SHSystemRoutine.h"
+#include "Scene/SHSceneGraph.h"
+#include "SHTransformComponent.h"
 
 namespace SHADE
 {
@@ -45,25 +45,30 @@ namespace SHADE
     /* System Routines                                                                 */
     /*---------------------------------------------------------------------------------*/
 
-    class SH_API TransformUpdateRoutine final: public SHSystemRoutine
+    class SH_API TransformPostLogicUpdate final: public SHSystemRoutine
     {
     public:
       /*-------------------------------------------------------------------------------*/
       /* Constructors & Destructor                                                     */
       /*-------------------------------------------------------------------------------*/
 
-      TransformUpdateRoutine   ();
-      ~TransformUpdateRoutine  () = default;
-
-      TransformUpdateRoutine   (const TransformUpdateRoutine&)  = delete;
-      TransformUpdateRoutine   (TransformUpdateRoutine&&)       = delete;
+      TransformPostLogicUpdate   ();
 
       /*-------------------------------------------------------------------------------*/
-      /* Operator Overloads                                                            */
+      /* Function Members                                                              */
       /*-------------------------------------------------------------------------------*/
 
-      TransformUpdateRoutine& operator= (const TransformUpdateRoutine&) = delete;
-      TransformUpdateRoutine& operator= (TransformUpdateRoutine&&)      = delete;
+      void Execute(double dt) noexcept override;
+    };
+
+    class SH_API TransformPostPhysicsUpdate final: public SHSystemRoutine
+    {
+    public:
+      /*-------------------------------------------------------------------------------*/
+      /* Constructors & Destructor                                                     */
+      /*-------------------------------------------------------------------------------*/
+
+      TransformPostPhysicsUpdate   ();
 
       /*-------------------------------------------------------------------------------*/
       /* Function Members                                                              */
@@ -84,8 +89,14 @@ namespace SHADE
     /* Function Members                                                                */
     /*---------------------------------------------------------------------------------*/
 
-    static void UpdateEntity   (const SHSceneNode* node);
-    static void UpdateTransform(SHTransformComponent& tf, const SHTransformComponent* parent = nullptr);
+    static void   UpdateChildrenLocalTransforms (SHSceneNode* node);
+
+    static void   UpdateEntity                  (const SHSceneNode* node, bool clearDirtyFlag);
+    static void   UpdateTransform               (SHTransformComponent& tf, const SHTransformComponent* parent = nullptr);
+
+    // Event Handlers
+
+    SHEventHandle ChangeParent                  (SHEventPtr changeParentEvent);
   };
 
 
diff --git a/SHADE_Engine/src/Math/Vector/SHVec4.cpp b/SHADE_Engine/src/Math/Vector/SHVec4.cpp
index bcf2ef97..9857818a 100644
--- a/SHADE_Engine/src/Math/Vector/SHVec4.cpp
+++ b/SHADE_Engine/src/Math/Vector/SHVec4.cpp
@@ -38,6 +38,10 @@ namespace SHADE
   : XMFLOAT4( 0.0f, 0.0f, 0.0f, 0.0f )
   {}
 
+  SHVec4::SHVec4(const SHVec3& vec3) noexcept
+  : XMFLOAT4( vec3.x, vec3.y, vec3.z, 1.0f )
+  {}
+
   SHVec4::SHVec4(const XMFLOAT4& xmfloat4) noexcept
   : XMFLOAT4( xmfloat4.x, xmfloat4.y, xmfloat4.z, xmfloat4.w )
   {}
@@ -271,6 +275,11 @@ namespace SHADE
     return result;
   }
 
+  SHVec3 SHVec4::ToVec3() const noexcept
+  {
+    return SHVec3{ x, y, z };
+  }
+
   /*-----------------------------------------------------------------------------------*/
   /* Static Function Member Definitions                                                */
   /*-----------------------------------------------------------------------------------*/
diff --git a/SHADE_Engine/src/Math/Vector/SHVec4.h b/SHADE_Engine/src/Math/Vector/SHVec4.h
index 911a714e..ce341bed 100644
--- a/SHADE_Engine/src/Math/Vector/SHVec4.h
+++ b/SHADE_Engine/src/Math/Vector/SHVec4.h
@@ -16,6 +16,7 @@
 
 // Project Headers
 #include "SH_API.h"
+#include "SHVec3.h"
 
 namespace SHADE
 {
@@ -53,6 +54,7 @@ namespace SHADE
     ~SHVec4 ()                  = default;
 
     SHVec4  ()                                    noexcept;
+    SHVec4  (const SHVec3& vec3)                  noexcept;
     SHVec4  (const XMFLOAT4& xmfloat4)            noexcept;
     SHVec4  (float x, float y, float z, float w)  noexcept;
 
@@ -102,16 +104,18 @@ namespace SHADE
     [[nodiscard]] float         Dot3D           (const SHVec4& rhs)                   const noexcept;
     [[nodiscard]] SHVec4        Cross3D         (const SHVec4& rhs)                   const noexcept;
     [[nodiscard]] SHVec4        Cross           (const SHVec4& v1, const SHVec4& v2)  const noexcept;
+
+    [[nodiscard]] SHVec3        ToVec3          ()                                    const noexcept;
   
     /*---------------------------------------------------------------------------------*/
     /* Static Function Members                                                         */
     /*---------------------------------------------------------------------------------*/
 
-    [[nodiscard]] static SHVec4 Normalise         (const SHVec4& v)                                                              noexcept;
-    [[nodiscard]] static SHVec4 Normalise3D       (const SHVec4& v)                                                              noexcept;
-    [[nodiscard]] static SHVec4 Abs               (const SHVec4& v)                                                              noexcept;
-    [[nodiscard]] static SHVec4 Min               (const std::initializer_list<SHVec4>& vs)                                      noexcept;
-    [[nodiscard]] static SHVec4 Max               (const std::initializer_list<SHVec4>& vs)                                      noexcept;
+    [[nodiscard]] static SHVec4 Normalise         (const SHVec4& v)                                                                 noexcept;
+    [[nodiscard]] static SHVec4 Normalise3D       (const SHVec4& v)                                                                 noexcept;
+    [[nodiscard]] static SHVec4 Abs               (const SHVec4& v)                                                                 noexcept;
+    [[nodiscard]] static SHVec4 Min               (const std::initializer_list<SHVec4>& vs)                                         noexcept;
+    [[nodiscard]] static SHVec4 Max               (const std::initializer_list<SHVec4>& vs)                                         noexcept;
     [[nodiscard]] static SHVec4 Clamp             (const SHVec4& v, const SHVec4& vMin, const SHVec4& vMax)                         noexcept;
     [[nodiscard]] static SHVec4 Lerp              (const SHVec4& a, const SHVec4& b, float t)                                       noexcept;
     [[nodiscard]] static SHVec4 ClampedLerp       (const SHVec4& a, const SHVec4& b, float t, float tMin = 0.0f, float tMax = 1.0f) noexcept;
diff --git a/SHADE_Engine/src/Physics/Components/SHColliderComponent.cpp b/SHADE_Engine/src/Physics/Components/SHColliderComponent.cpp
index 71183f00..75a00491 100644
--- a/SHADE_Engine/src/Physics/Components/SHColliderComponent.cpp
+++ b/SHADE_Engine/src/Physics/Components/SHColliderComponent.cpp
@@ -26,7 +26,6 @@ namespace SHADE
 
   SHColliderComponent::SHColliderComponent() noexcept
   : system    { nullptr }
-  , colliders {}
   {}
 
   /*-----------------------------------------------------------------------------------*/
@@ -69,31 +68,24 @@ namespace SHADE
   void SHColliderComponent::OnCreate()
   {
     system = SHSystemManager::GetSystem<SHPhysicsSystem>();
-    if (!system)
-    {
-      SHLOG_ERROR("Physics system does not exist, Collider Component not added!")
-      return;
-    }
-
-    system->AddCollider(GetEID());
   }
 
   void SHColliderComponent::OnDestroy()
   {
-    if (!system)
-    {
-      SHLOG_ERROR("Physics system does not exist, unable to remove Collider component!")
-      return;
-    }
 
-    system->RemoveCollider(GetEID());
   }
 
   SHBoundingBox* SHColliderComponent::AddBoundingBox(const SHVec3& halfExtents, const SHVec3& posOffset) noexcept
   {
-    const auto TYPE = SHCollider::Type::BOX;
+    if (!system)
+    {
+      SHLOG_ERROR("Physics system does not exist, unable to add Box Collider!")
+      return nullptr;
+    }
 
-    auto boxPair = std::make_pair(SHCollider{TYPE}, true);
+    static constexpr auto TYPE = SHCollider::Type::BOX;
+
+    auto boxPair = std::make_pair(SHCollider{ TYPE }, true);
     auto& collider = colliders.emplace_back(boxPair).first;
 
     const auto* tf = SHComponentManager::GetComponent<SHTransformComponent>(GetEID());
@@ -101,12 +93,6 @@ namespace SHADE
     collider.SetPositionOffset(posOffset);
     collider.SetAsBoundingBox(tf->GetWorldScale() * halfExtents);
 
-    if (!system)
-    {
-      SHLOG_ERROR("Physics system does not exist, unable to add Box Collider!")
-      return nullptr;
-    }
-
     // Notify Physics System
     system->AddCollisionShape(GetEID(), &collider);
 
@@ -115,7 +101,13 @@ namespace SHADE
 
   SHBoundingSphere* SHColliderComponent::AddBoundingSphere(float radius, const SHVec3& posOffset) noexcept
   {
-    const auto TYPE = SHCollider::Type::SPHERE;
+    if (!system)
+    {
+      SHLOG_ERROR("Physics system does not exist, unable to add Sphere Collider!")
+      return nullptr;
+    }
+
+    static constexpr auto TYPE = SHCollider::Type::SPHERE;
 
     auto spherePair = std::make_pair(SHCollider{ TYPE }, true);
     auto& collider = colliders.emplace_back(spherePair).first;
@@ -126,13 +118,7 @@ namespace SHADE
 
     const SHVec3 TF_WORLD_SCALE = tf->GetWorldScale();
     const float MAX_SCALE = SHMath::Max({ TF_WORLD_SCALE.x, TF_WORLD_SCALE.y, TF_WORLD_SCALE.z });
-    collider.SetAsBoundingSphere(MAX_SCALE * 0.5f);
-
-    if (!system)
-    {
-      SHLOG_ERROR("Physics system does not exist, unable to add Sphere Collider!")
-      return nullptr;
-    }
+    collider.SetAsBoundingSphere(MAX_SCALE * 0.5f * radius);
 
     // Notify Physics System
     system->AddCollisionShape(GetEID(), &collider);
